#!/usr/bin/perl
use utf8;
#------------------------------------------------
#ver 1.2

my $password = 'cgitest';			#管理人パスワード
my $title = '掲示板';				#タイトル
my $home = '../index.html';			#HPアドレス
my $non_name = '名無しさん';		#名前未入力時の表示名
my $logpath = '/cgi-bin/data/';		#ログディレクトリのパス
my $logmax = 300;					#最大記録ログ件数
my $maxline = 5;					#1ページの表示件数
my $mojisu = 300;					#一件の最大文字数
my $back_img = '';					#背景画像のパス
my $style = [
	'#ffffff',						#背景カラー
	'#000000',						#テキストカラー
	'blue',							#リンクカラー
	'purple',						#訪問済みリンクカラー
];

# 設定ここまでです。-----------------------------


#use strict;
#use CGI::Carp qw(fatalsToBrowser);
use Fcntl qw(:DEFAULT :flock);
use CGI;
use CGI::Cookie;

use open ":utf8"; 
use Encode qw(from_to decode encode);
#use cotatu_mbord_sub;

my $cgi = CGI->new();
my $rhash = &get_formdata($cgi);
my $rcookie = &get_cookie;
my $mode = $rhash ->{'mode'} || 'view';

my $info = {
	CGI => $cgi,
	LOGPATH => $logpath . 'mbbs.log',
	OVERLOGPATH => $logpath . 'over_mbbs.log',
	SCRIPT => "$ENV{'SCRIPT_NAME'}\?",
	UA => $ENV{'HTTP_USER_AGENT'},
	HOME_ADDR => $home,
	COOKIE => $rcookie,
	TITLE => $title,
	FORMDATA => $rhash,
	MODE => $mode,
	TIME => &get_time,
	NON_NAME => $non_name,
	PASSWORD => $password,
	LOGMAX => $logmax,
	MAXLINE => $maxline,
	MOJISU => $mojisu,
	COLOR => $style,
	BACK_IMG => $back_img,
};

eval{
		{
		'view' => \&view,
		'form' => \&form,
		'post' => \&post,
		'edit' => \&edit,
		'edit_data' => \&edit_data,
		'delete_data' => \&delete_data,
		'refer' => \&refer,
		'search' => \&search,
		'admin_login' => \&admin_login,
		'admin_hani_delete' => \&admin_hani_delete,
		'admin_word_delete' => \&admin_word_delete,
		'admin_all_delete' => \&admin_all_delete,
	}->{$mode}->($info);
};

if($@){&error("不正な操作です:$@");}
exit;

# メイン処理---------------------------------------

sub view{
	my $info = shift;
	&check_getdata($info);
	my $rdata = &read_filedata($info->{'LOGPATH'});
	my $string = &make_lines($info,$rdata);
	&display_HTML($info,$string);
}

sub form{
	my $info = shift;
	my $string = &make_form($info);
	&display_HTML($info,$string);
}

sub post{
	my $info = shift;
	&check_necessary($info,['comment']);
	&check_formdata($info);
	&mold_add_data($info);
	&change_cookie($info);
	$info->{'MODE'} = 'view';
	&view($info);
}


sub edit{
	my $info = shift;
	&check_necessary($info,['num']);
	&check_formdata($info);
	my $string = &make_edit_form($info);
	&display_HTML($info,$string);
}

sub edit_data{
	my $info = shift;
	&check_necessary($info,['comment','num','password']);
	&check_formdata($info);
	&check_edit_flag($info);
	&add_editdata($info);
	&change_cookie($info);
	$info->{'MODE'} = 'view';
	&view($info,);
}

sub delete_data{
	my $info = shift;
	&check_necessary($info,['num','password']);
	&check_formdata($info);
	&check_edit_flag($info);
	&delete_file($info->{'FORMDATA'}->{'num'},$info->{'LOGPATH'});
	$info->{'MODE'} = 'view';
	&view($info);
}

sub refer{
	my $info = shift;
	&check_getdata($info);
	my $string = &make_reference($info);
	&display_HTML($info,$string);
}

sub search{
	my $info = shift;
	&check_getdata($info);
	my ($string,$rdata) = &search_data($info);
	$string .= &make_lines($info,$rdata);
	&display_HTML($info,$string);
}

sub admin_login{
	my $info = shift;
	&check_formdata($info);
	my $str = &make_loginpage($info);
	&display_HTML($info,$str);
}


sub admin_hani_delete{
	my $info = shift;
	&admin_pass_check($info);
	my $str = &hani_delete($info);
	$str .= &make_maintenance($info);
	&display_HTML($info,$str);
}

sub admin_word_delete{
	my $info = shift;
	&admin_pass_check($info);
	my $str = &word_delete($info);
	$str .= &make_maintenance($info);
	&display_HTML($info,$str);
}

sub admin_all_delete{
	my $info = shift;
	&admin_pass_check($info);
	my $str = &all_delete($info->{'LOGPATH'});
	$str .= &make_maintenance($info);
	&display_HTML($info,$str);
}
	
# 画面表示関係 -----------------------------------------------

sub error{
	my $mes   = shift;
	#$mes = &tag_escape($mes);

	my $html =<<EOL;
<!DOCTYPE html PUBLIC"-//W3C//DTD XHTML1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">

<head> 
<title>error</title> 
</head> 
<body>
<h1>error</h1>
<p>
ｴﾗｰが発生しました
</p>
<p>
$mes
</p>
</body>
</html>
EOL

	utf8::encode($html);
	from_to($html, 'utf8','shiftjis');
	print "Content-type: text/html; charset=shiftjis\n\n";
	print $html;
	exit;
}

sub display_HTML{
	my ($info,$str) = @_;
	my $rcookie = $info->{'COOKIE'};
	

	my $html  = &header($info);
	$html .= $str;
	$html .= &footer($info);
	
	my $mime = ();
	unless($info->{'UA'} =~ /^DoCoMo\/2/){
		$mime = 'text/html';
	}else{
		$mime = 'application/xhtml+xml';
	}
	
	utf8::encode($html);
	from_to($html, 'utf8','shiftjis');
	my $byte = length($html);
	&output_cookie($info);
	
	print $info->{'CGI'}->header(-cookie => $rcookie->{'user'}, -charset => 'Shift_JIS', -type => $mime, -Length => $byte);

	print $html;
}


sub header{
	my $info = shift;
	my ($back_color,$text,$link,$vlink) = @{$info->{'COLOR'}};
	
	my $title = &tag_escape($info->{'TITLE'});
	
	my $html =<<EOL;
<?xml version="1.0" encoding="Shift_JIS"?> 
<!DOCTYPE html PUBLIC "-//OPENWAVE//DTD XHTML Mobile 1.0//EN" 
"http://www.openwave.com/dtd/xhtml-mobile10.dtd"> 
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja">
<head> 
<title>$info->{'TITLE'}</title> 
<style type="text/css">
<![CDATA[
a:link{color:$link}
a:visited{color:$vlink}
]]>
</style> 
</head>

<body style="background-color:$back_color; color:$text; background-image: url($info->{'BACK_IMG'});">

<div id="header">
<h1 style="text-align:center"><a href="$info->{'SCRIPT'}" style="text-decoration:none">$info->{'TITLE'}</a></h1>
<hr />

<p style="text-align:center">
[<a href="$info->{'SCRIPT'}\&amp;mode=form">投稿</a>]
[<a href="$info->{'SCRIPT'}\&amp;mode=search">検索</a>]
[<a href="$info->{'HOME_ADDR'}">HP</a>]
</p>
<hr />
</div>

<div id="container">
EOL
	return $html;
}

sub footer{
	my $info = shift;
	
	my $adminuri = ();
	unless($info->{'ADMIN_FLAG'}){
	$adminuri = qq|<p id="admin" style="text-align:center"><a href="$info->{'SCRIPT'}\&amp;mode=admin_login">管理者用</a></p>|;
	}
	
	my $html =<<EOL;
</div>

<div id="footer">
<p style="text-align:center">
[<a href="$info->{'SCRIPT'}\&amp;mode=form">投稿</a>]
[<a href="$info->{'SCRIPT'}\&amp;mode=search">検索</a>]
[<a href="$info->{'HOME_ADDR'}">HP</a>]
</p>
$adminuri
</div>
</body>
</html>
EOL
	return $html;
}

# ページ作成関係 -----------------------------------------------

sub make_form{
	my $info = shift;
	my $rcookie = $info->{'COOKIE'};
	my $script = $info->{'SCRIPT'};
	my $mojisu = $info->{'MOJISU'};
	
	my $uri = ();
	if($rcookie->{'c_uri'}){
		$uri = $rcookie->{'c_uri'};
	}else{
		$uri = 'http://';
	}
	
	my $html =<<EOL;

<form method="post" action="$script" style="margin:0.3em">
<input type="hidden" name="mode" value="post" />

<p>
▽お名前<br />
<input type="text" maxlength="20" name="username" value="$rcookie->{'c_name'}" />
</p>
<p>
▽E-mail<br />
<input type="text" maxlength="100" name="email" value="$rcookie->{'c_email'}" />
</p>
<p>
▽ﾌﾟﾛﾌｨｰﾙ or HP<br />
<input type="text" maxlength="200" name="uri" value="$uri" />
</p>
<p>
▽本文<br />
<textarea cols="50" rows="8" wrap="soft"  name="comment"></textarea>
</p>
<p>
Password<br />
<input type="password" size="8" maxlength="8" name="password" value="$rcookie->{'c_password'}" />
</p>
<p>
<input type="submit" name="submit" value=" 送信 " />
<input type="reset"  name="reset"  value=" リセット " />
</p>

</form>
EOL
	return $html;
}

sub make_lines{
	my ($info,$rdata) = @_;
		
	my $max_line = $info->{'MAXLINE'};

	my $all = @$rdata;
	unless($all){return '<p>記事がありません</p>';}

	my $max_page  = int($all / $max_line);
	$max_page++ if $all % $max_line ;

	my $this_page = $info->{'FORMDATA'}->{'this_page'} || 1;
	my $which     = $info->{'FORMDATA'}->{'which'}     || "";

	if($which eq 'next'){
		$this_page++;
	}elsif($which eq 'before'){
		$this_page--;
	}

	$this_page = 1         if $this_page < 1;
	$this_page = $max_page if $this_page > $max_page;
	
	@$rdata = reverse @$rdata;
	my $start = ($this_page - 1) * $max_line;
	my $end = $this_page * $max_line - 1;
	my @lines = @$rdata[$start .. $end];
	

	my $page_link = ();
	if($all > $max_line){
	$page_link = &make_page_link($info, $all, $max_page, $this_page);
	}
	
	my $comment = ();
	foreach(@lines){
    	chomp;
		next if $_ =~ /^\s*$/;
		$comment .= &get_one_line($info,$_);
	}
	
		
	my $html = <<EOL;
$page_link
<div id="comments" style="margin:0.3em">
$comment
</div>
$page_link

<form method="post" action="$info->{'SCRIPT'}">
<input type="hidden" name="mode" value="edit" />
<p>No:
<input type="text" size="4" maxlength="4" name="num" value="" />
<input type="submit" name="submit" value=" 編集 " />
</p>
</form>
EOL
		
	return $html;
}


sub get_one_line{
	my ($info,$line) = @_;
	
	my @line = my($num, $username, $email, $uri, $comment, $date) = split("\t",$line);

	$comment = &tag_escape($comment,1);
	$comment = &add_res($info,$comment);
	$comment =~ s|Enc_Line_Feed|<br />|g;


	if($date =~ /^(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2})(\d{2}$)/){
		$date = "$2/$3 $5:$6"
	}
	
	if($username){
		$username = &tag_escape($username);
	}else{
		$username = &tag_escape($info->{'NON_NAME'});
	}
	
	if($email){$username = &tag_escape("mailto:$email",2,$username)};
	if($uri){$uri = &tag_escape($uri,2,'profile');}
	


	my $string =<<EOL;
	<p class="line">
	$date No[$num]<br />
	▽$username $uri<br />
	$comment
	</p>
	<hr />
EOL
	return $string;
}


sub make_page_link{
	my ($info,$all,$max_page,$this_page) = @_;
	my $script    = $info->{'SCRIPT'};
	my $mode = $info->{'MODE'};
	
	$word = ();
	if($mode eq 'search'){
		$word = $info->{'FORMDATA'}->{'word'};
		$word = "\&amp;word\=$word";
	}

	my $befor_link;
	if($this_page > 1){
		my $uri = $script .qq|\&amp;mode=$mode&amp;this_page=$this_page&amp;which=before$word|;
		$befor_link = qq|<a href="$uri">[前]</a>|;
	}else{
		$befor_link = '[前]';
	}

	my $next_link;
	if($this_page < $max_page){
		my $uri = $script .qq|\&amp;mode=$mode&amp;this_page=$this_page&amp;which=next$word|;
		$next_link = qq|<a href="$uri">[次]</a>|;
	}else{
		$next_link = '[次]';
	}
	
	$start_link = ();
	if($this_page > 1){
		$start_link = qq|<a href="$script&amp;mode=$mode&amp;this_page=0$word">[新]</a>|;
	}else{
		$start_link = '[新]';
	}
	
	my $last_link = ();
		if($this_page < $max_page){
			$last_link = qq|<a href="$script&amp;mode=$mode&amp;this_page=9999$word">[後]</a>|;
	}else{
			$last_link = '[後]';
	}
	

	my $html =<<EOL;
	<p class="navi">
	$start_link $befor_link	$next_link $last_link 
	</p>
	<hr />
EOL
	return $html;
}

# 記事参照モード-----------------------------------------------
sub add_res{
	my ($info,$str) = @_;
	
	$str =~ s/\&gt\;\&gt\;(\d+)/<a href="$info->{'SCRIPT'}\&amp;mode\=refer\&amp;num\=$1">>>$1<\/a>/go;
	
	return $str;
}
 
sub make_reference{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	my $rdata = &read_filedata($info->{'LOGPATH'});
	
	my $line = &search_one_line($info->{'LOGPATH'},$rhash->{'num'});
	if($line){
		$line = &get_one_line($info,$line);
	}else{
		$line = '記事がありません';
	}
	
	my $html =<<EOL;
<dl id="comments">
	$line
</dl>
EOL
	return $html;	
}

# データ編集・削除機能関係 -----------------------------------------------

sub make_edit_form{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	my $script = $info->{'SCRIPT'};
	
	my $line = &search_one_line($info->{'LOGPATH'},$rhash->{'num'});
	unless($line){&error('記事がありません');}
	
	my ($num, $username, $email, $uri, $comment,$password) = (split("\t",$line))[0,1,2,3,4,7];
	$comment =~ s|Enc_Line_Feed|\x{000D}\x{000A}|g;
	
	my $html =<<EOL;
<form method="post" action="$script" style="margin:0.3em">
<input type="hidden" name="mode" value="edit_data" />
<input type="hidden" name="num" value="$num" />

<p>
	▽お名前<br />
	<input type="text" maxlength="20" name="username" value="$username" />
</p>
<p>
	▽E-mail<br />
	<input type="text" maxlength="100" name="email" value="$email" />
</p>
<p>
	▽ﾌﾟﾛﾌｨｰﾙ or HP<br />
	<input type="text" maxlength="200" name="uri" value="$uri" />
</p>
<p>
	▽本文<br />
	<textarea class="broad" cols="50" rows="8" wrap="soft"  name="comment">$comment</textarea>
</p>
<p>
	▽Password<br />
	<input type="password" size="8" maxlength="8" name="password" value="$info->{'COOKIE'}->{'c_password'}" />
</p>
<p>
	<input type="submit" name="submit" value=" 編集 " />
    <input type="reset"  name="reset"  value=" やり直し " />
</p>
</form>
<hr />
<form method="post" action="$script" style="margin:0.3em">
<input type="hidden" name="mode" value="delete_data" />
<input type="hidden" name="num" value="$num" />
<p>
	▽Password<br />
	<input type="password" size="8" maxlength="8" name="password" value="$info->{'COOKIE'}->{'c_password'}" />
	<input type="submit" name="submit" value=" 削除 " />
</p>
</form>
EOL
	return $html;
}
	
sub check_edit_flag{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	
	my $line = &search_one_line($info->{'LOGPATH'},$rhash->{'num'});
	unless($line){&error('記事がありません');}
	
	my $admin_flag = 0;
	if($rhash->{'password'} eq $info->{'PASSWORD'}){$admin_flag = 1;}
	
	my $delete_flag = 0;
	my ($num,$password) = (split(/\t/,$line))[0,7];
	if($password eq $rhash->{'password'}){$delete_flag = 1;}
	
	if(!($admin_flag or $delete_flag)){&error('ﾊﾟｽﾜｰﾄﾞが違います');}
	
	return;
}

sub delete_file{
	my ($num,$path) = @_;
	
	my $fh = *FH;
	&fileopen($fh,"+<:utf8",$path);
	&filelock($fh,LOCK_EX);
	
	my @data = ();
	@data = grep(!/^$num\t/,<$fh>);
	
	seek($fh, 0, 0);
	truncate($fh, 0);
	foreach(@data){print $fh $_};
	&fileclose($fh);
	
	return;
}


sub add_editdata{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	my $num = $rhash->{'num'};
	
	my $timedata = $info->{'TIME'};
	$rhash->{'comment'} =~ s/\n/Enc_Line_Feed/g;
	
	my @savedata = ();
	push(@savedata, $num || "");
	push(@savedata, $rhash->{'username'} || "");
	push(@savedata, $rhash->{'email'} || "");
	push(@savedata, $rhash->{'uri'} || "");
	push(@savedata, $rhash->{'comment'} || "");
	push(@savedata, $timedata || "");
	push(@savedata, $ENV{'REMOTE_ADDR'} || "");
	push(@savedata, $rhash->{'password'} || "");
	
	my $fh = *FH;
	&fileopen($fh,"+<:utf8",$info->{'LOGPATH'});
	&filelock($fh,LOCK_EX);
	
	my @data = ();
	foreach(<$fh>){
		if ($_ !~ /^$num\t/){
			push(@data,$_);
		}else{
			push(@data,join("\t",@savedata)."\n");
		}
	}
			
	seek($fh,0,0);
	truncate($fh,0);
		
	foreach(@data){print $fh $_;}
	&fileclose($fh);
	return;
}

# 記事検索関係 -----------------------------------------------
sub search_data{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	my $word = $rhash->{'word'};
	my @word_type = $info->{'CGI'}->param('word_type');
	
	
#	$word =~ tr/\x81\x40/ /;
	$word =~ tr/　/ /;
	$word =~ tr/ //s;
	$word =~ s/^\s//;
	$word =~ s/\s$//;
	
	my @wordlist = split(/ /,$word);
	
	my $str = ();
	$str =<<EOL;
<form method="post" action="$info->{'SCRIPT'}" style="margin:0.3em">
<input type="hidden" name="mode" value="search" />
<input type="hidden" name="set" value="$info->{'SET'}" />
<p>
検索ｷｰﾜｰﾄﾞ入力
</p>
<p>
名前:
<input type="checkbox" name="word_type" value="username" checked="checked" />
本文:
<input type="checkbox" name="word_type" value="comment" checked="checked" />
<br />
<input type="text" name="word" value="@wordlist" /><br />
<!-- cotatu.script cotatu.undo.jp/-->
<input type="submit" name="submit" value=" 検索 " />
</p>
</form>
<hr />

EOL

	unless($word){&display_HTML($info,$str);exit;}
	
	my $nameflag = 0;
	my $comflag = 0;
	foreach(@word_type){
		if($_ =~ /^username$/){
			$nameflag = 1;
		}elsif($_ =~ /^comment$/){
			$comflag = 1;
		}
	}

	my $rdata = &read_filedata($info->{'LOGPATH'});
	 
	my @buf = ();
	foreach my $s(@wordlist){
		foreach(@$rdata){
			chomp;
			my($name,$comment) = (split(/\t/,$_))[1,4];
			unless($name){$name = $info->{'NON_NAME'};}
			
			if($nameflag and $comflag){
				if($comment =~ /$s/ or $name =~ /$s/){push @buf,$_;}
			}elsif($nameflag){if($name =~ /$s/){push @buf,$_;}
			}elsif($comflag){if($comment =~ /$s/){push @buf,$_;}
			}
		}
		@$rdata = @buf;
		@buf = ();
	}
	
	my $all = @$rdata;
	
	if(@$rdata){
			$word = &uri_encode($word);
			if($nameflag){$word = $word . '&amp;word_type=username';}
			if($comflag){$word = $word . '&amp;word_type=comment';}
			
			$rhash->{'word'} = $word;
			return "<p>検索結果 $all 件<\/p>\n",$rdata;
		}else{
			$str .= '<p>見つかりませんでした。</p>';
			&display_HTML($info,$str);
			exit;
		}

}

sub search_one_line{
	my ($path,$key) = @_;
	
	my $fh = *FH;
	&fileopen($fh,"<:utf8",$path);
	&filelock($fh,LOCK_SH);
	
	my $line = ();
	foreach(<$fh>){
		if($_ =~ /^$key\t/){
			chomp;
			$line = $_;
			last;
		}
	}
	&fileclose($fh);
	
	if($line){
		return $line;
	}else{
		return 0;
	}
}

# 管理モード-----------------------------------------------
sub make_loginpage{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	
	$info->{'ADMIN_FLAG'} = 1;
	
	my $html = ();
	if($rhash->{'password'}){
		if($rhash->{'password'} eq $info->{'PASSWORD'}){
			$html = &make_maintenance($info);
			return $html;
		}else{
			&error('ﾊﾟｽﾜｰﾄﾞが違います');
		}
	}
		
	$html =<<EOL;
<form method="post" action="$info->{'SCRIPT'}" style="margin:0.3em">
	<input type="hidden" name="mode" value="admin_login" />
	<p>
	ﾊﾟｽﾜｰﾄﾞ:<br />
	<input type="password" size="8" maxlength="8" name="password" value="" />
	<input type="submit" name="submit" value=" ﾛｸﾞｲﾝ " />
	</p>
</form>

EOL
	return $html;
}

sub make_maintenance{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	$info->{'ADMIN_FLAG'} = 1;
	
	my $html=<<EOL;
<form method="post" action="$info->{'SCRIPT'}" style="margin:0.3em">
<input type="hidden" name="mode" value="admin_hani_delete" />
<input type="hidden" name="password" value="$rhash->{'password'}" />
<p>
範囲指定削除<br />
<input type="text" size="4" maxlength="4" name="num" value="" />
-
<input type="text" size="4" maxlength="4" name="num" value="" />
<br />
<input type="submit" name="submit" value=" 削除 " />
</p>
</form>

<form method="post" action="$info->{'SCRIPT'}" style="margin:0.3em">
<input type="hidden" name="mode" value="admin_word_delete" />
<input type="hidden" name="password" value="$rhash->{'password'}" />
<p>
ﾜｰﾄﾞ指定削除<br />
名前:
<input type="checkbox" name="word_type" value="username" checked="checked" />
本文:
<input type="checkbox" name="word_type" value="comment" checked="checked" />
<br />
<input type="text" name="word" value="" />
<br />
<input type="submit" name="submit" value=" 削除 " />
</p>
</form>

<form method="post" action="$info->{'SCRIPT'}" style="margin:0.3em">
<input type="hidden" name="mode" value="admin_all_delete" />
<input type="hidden" name="password" value="$rhash->{'password'}" />
<p>
全て削除<br />
<input type="submit" name="submit" value=" 全削除 " />
</p>
</form>
EOL

	return $html;
}

sub admin_pass_check{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	$info->{'ADMIN_FLAG'} = 1;
	
	if($rhash->{'password'} ne $info->{'PASSWORD'}){
			&error('不正な操作です');
	}
	return;
}

sub hani_delete{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	$info->{'ADMIN_FLAG'} = 1;
	
	unless($info->{'CGI'}->param('num')){return "0 件削除しました";}
	my @num = $info->{'CGI'}->param('num');
	foreach(@num){
		if($_ =~ /[^0-9]/){return '半角数字を入力してください';}
	}

	@num = sort {$a <=> $b} @num;
	
	my $fh = *FH;
	&fileopen($fh, "+<:utf8", $info->{'LOGPATH'});
	&filelock($fh,LOCK_EX);
	
	@data = <$fh>;
	my $all = @data;
	
	if($num[0] >= 1){
		OUTER: foreach my $s($num[0] .. $num[1]){
			my $count = 0;
			foreach(@data){
				if($_ =~ /^$s\t/){
					splice(@data,$count,1);
					next OUTER;
				}
				$count++;
			}
		}
	}else{
		@data = grep(!/^$num[1]\t/,@data);
	}
	
	seek($fh, 0, 0);
	truncate($fh, 0);
	foreach(@data){print $fh $_};
	&fileclose($fh);
	
	$all -= @data;

	return "$all 件削除しました";
}

sub word_delete{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	$info->{'ADMIN_FLAG'} = 1;
	my @word_type = $info->{'CGI'}->param('word_type');
	my $word = $rhash->{'word'};
	
	$word =~ tr/　/ /;
	$word =~ tr/ //s;
	$word =~ s/^\s//;
	$word =~ s/\s$//;
	if(!$word){return "0 件削除しました";}
	my @wordlist = split(/ /,$word);
	
	my $nameflag = 0;
	my $comflag = 0;
	foreach(@word_type){
		if($_ =~ /^username$/){
			$nameflag = 1;
		}elsif($_ =~ /^comment$/){
			$comflag = 1;
		}
	}
	
	my $fh = *FH;
	&fileopen($fh, "+<:utf8", $info->{'LOGPATH'});
	&filelock($fh,LOCK_EX);
	
	@data = <$fh>;
	my $all = @data;
	my @new_data = @data;

	my @buf = ();
	foreach my $s(@wordlist){
		foreach(@data){
			chomp;
			my($name,$comment) = (split(/\t/,$_))[1,4];
			unless($name){$name = $info->{'NON_NAME'};}
			
			if($nameflag and $comflag){
				if($comment =~ /$s/ or $name =~ /$s/){push @buf,$_;}
			}elsif($nameflag){if($name =~ /$s/){push @buf,$_;}
			}elsif($comflag){if($comment =~ /$s/){push @buf,$_;}
			}
		}
		@data = @buf;
		@buf = ();
	}
	
	OUTER: foreach my $s(@data){
		my $count = 0;
		foreach (@new_data){
			(my $num) = (split(/\t/,$s))[0];
			if($_ =~ /^$num\t/){
				splice(@new_data,$count,1);
				next OUTER;
			}
			$count++;
		}
	}

	seek($fh, 0, 0);
	truncate($fh, 0);
	foreach(@new_data){print $fh $_};
	&fileclose($fh);
	
	$all -= @new_data;
	return "$all 件削除しました";
	
}

sub all_delete{
	my $path = shift;
	
	my $fh = *FH;
	&fileopen($fh, "+<:utf8",$path);
	&filelock($fh,LOCK_EX);
	
	@data = <$fh>;
	my $all = @data;
	
	seek($fh, 0, 0);
	truncate($fh, 0);
	&fileclose($fh);

	return "$all 件削除しました";
}


# データチェック関係 -----------------------------------------------

sub check_getdata{
	my $info     = shift;
	my %hash = %{$info->{'FORMDATA'}};

	if($hash{'this_page'} && $hash{'this_page'} =~ /[^0-9]/ ){
		&error('不正な操作です');
	}

	if($hash{'which'} && !($hash{'which'} eq 'before'||$hash{'which'} eq 'next')){
		&error('不正な操作です');
	}
	
	if($hash{'num'} && $hash{'num'} =~ /[^0-9]/ ){
		&error('不正な操作です');
	}
	
	return;
}

sub check_necessary{
	my $info = shift;
	my $item = shift;
	my $rhash = $info->{'FORMDATA'};
	
	my @non = ();
	foreach(@$item){
		unless($rhash->{$_}){push @non,$_;}
	}
	
	if($#non > -1){&error("次の項目を入力してください。<br />\n". join("<br />\n", @non) . "\n");}
	return;
}

sub check_formdata{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};

	my @error = ();
	
	if($rhash->{'username'} && length($rhash->{'username'}) > 20){
		push(@error,'名前は20文字以内で入力してください');
	}
	
	if($rhash->{'comment'} && length($rhash->{'comment'}) > $info->{'MOJISU'}){
		push(@error, "本文は$info->{MOJISU}文字以内で入力してください");
	}

	if($rhash->{'email'} && !&check_mailaddr($rhash->{'email'})){
		push(@error, 'E-mailが不正です');
	}
	
	delete $rhash->{'uri'} if ($rhash->{'uri'} eq 'http://');
	if($rhash->{'uri'} && !&check_uri($rhash->{'uri'})){
		push(@error, 'Uriが不正です。');
	}
	
	if($rhash->{'password'} && $rhash->{'password'} !~ /^[A-Za-z0-9]{1,8}$/ ){
		push(@error, 'ﾌﾟﾛﾌｨｰﾙが不正です。');
	}
	
	if($rhash->{'num'} && $rhash->{'num'} =~ /[^0-9]/ ){
		push(@error, '記事番号は半角数字で入力してください');
	}
	
	
	if($rhash->{'editmode'} && !($rhash->{'editmode'} eq 'edit'||$rhash->{'editmode'} eq 'delete')){
		&error('編集か削除を選択してください');
	}
		
	if($#error > -1){&error(join("<br />\n", @error));}

	return;
}

sub check_mailaddr{ #1がOK
	my $mail = shift;
	if($mail =~ /[^a-zA-Z0-9\@\.\-\_]/){return 0};
	if ($mail =~ /^([\w ! \. - ,]+)@([\w ! \. - ,]+$)/){
		return 1;
	}else{
		return 0;
	}
}

sub check_uri{
	my $uri = shift;
	if($uri =~ /[^0-9A-Za-z\;\/\?\:\@\&\=\+\$\,\[\]\-\_\.\!\~\*\'\(\)\%]/){return 0};
	if($uri !~ /^(http|https):/){
		return 0;
	}else{
		return 1;
	}
}

sub tag_escape{
	my $string = shift;
	my $uriflag = shift; #0はノーマル。1はhttpリンク作成。2は$wordにリンク作成
	my $word = shift;
	
	my %escape = (
		'<' => "&lt;",
		'>' => "&gt;",
		'&' => "&amp;",
		'"' => "&quot;",
		"'" => "&#39;",
		);
	
	if(!$uriflag){
		$string =~ s/([<>&\"\'])/$escape{$1}/g;
		return $string;
	}
	
	if($uriflag == 1){
		$string =~ s{([<>&\"\']|(?:(?:http|https|ftp|mailto):[0-9A-Za-z\;\/\?\:\@\&\=\+\$\,\[\]\-\_\.\!\~\*\'\(\)\%]+))}{length($1) == 1 ? $escape{$1} : qq(<a href="$1">$1</a>);}exg;
		return $string;
	}
	
	if($uriflag == 2){
		$string =~ s{([<>&\"\']|(?:(?:http|https|ftp|mailto):[0-9A-Za-z\;\/\?\:\@\&\=\+\$\,\[\]\-\_\.\!\~\*\'\(\)\%]+))}{length($1) == 1 ? $escape{$1} : qq(<a href="$1">$word</a>);}exg;
		return $string;
	}
}


# クッキー関係-----------------------------------------------
sub get_cookie{
	my %cookies = fetch CGI::Cookie;
	my $c_user = $cookies{'user'};
	my $c_faith = $cookies{'faith'};
	
	my %cookie = (
	c_name => $c_user->{'value'}->[0],
	c_email => $c_user->{'value'}->[1], 
	c_uri => $c_user->{'value'}->[2],
	c_password => $c_user->{'value'}->[3],
	);

	foreach(keys %cookie){
		next if $cookie{$_} =~ /^\s*$/;
		$cookie{$_} = decode('shiftjis', $cookie{$_});
	}
	
	return \%cookie;
}
	
	
sub change_cookie{
	my $info = shift;
	my $rhash = $info->{'FORMDATA'};
	my $rcookie = $info->{'COOKIE'};
	
	if($rhash->{'username'}){
		$rcookie->{'c_name'} = $rhash->{'username'};
	}else{
		$rcookie->{'c_name'} = "";
	}
	
	if($rhash->{'email'}){
		$rcookie->{'c_email'} = $rhash->{'email'};
	}else{
		$rcookie->{'c_email'} = "";
	}
	if($rhash->{'uri'}){
		$rcookie->{'c_uri'} = $rhash->{'uri'};
	}else{
		$rcookie->{'c_uri'} = "";
	}
	if($rhash->{'password'}){
		$rcookie->{'c_password'} = $rhash->{'password'};
	}else{
		$rcookie->{'c_password'} = "";
	}

	return;
}

sub output_cookie{
	my $info = shift;
	my $rcookie = $info->{'COOKIE'};
	
	foreach(keys %$rcookie){
		next if $rcookie->{$_} =~ /^\s*$/;
		utf8::encode($rcookie->{$_});
		from_to($rcookie->{$_}, 'utf8','shiftjis');
	}
	
	my $name = $rcookie->{'c_name'} || "";
	my $email = $rcookie->{'c_email'};
	my $uri = $rcookie->{'c_uri'};
	my $password = $rcookie->{'c_password'};
	
	$user = new CGI::Cookie(-name=>'user', value=>[$name,$email,$uri,$password] , -expires=>'+6M');
	
	$rcookie->{'user'} = $user;
	
	return;
}

# ファイル操作関係 -----------------------------------------------
sub read_filedata{
	my $logpass = shift;

	my $fh = *FH;
	&fileopen($fh, "<:utf8", $logpass);
	&filelock($fh,LOCK_SH);
	my @data = <$fh>;
	&fileclose($fh);
	return \@data;
}

sub get_formdata{
	my $cgi = shift;
	my @hashkey = $cgi->param;
	
	my %hash;
	foreach my $key(@hashkey){
		$hash{$key} = decode('shiftjis', $cgi->param($key));
		next if $hash{$key} =~ /^\s*$/;
		
		$hash{$key} =~ s/\t//g;
		$hash{$key} =~ s/\x{000D}\x{000A}/\n/g;
		$hash{$key} =~ tr/\x{000D}\x{000A}/\n\n/;
		$hash{$key} =~ s/^\s+//;
		$hash{$key} =~ s/\s+$//;
	}
	return \%hash;
}

sub uri_encode{
	my $str = shift;
	
	utf8::encode($str);
	from_to($str, 'utf8','shiftjis');
	$str =~ tr/ /+/;
	$str =~ s/([^A-Za-z0-9\+])/'%'.unpack('H2',$1)/ego;
	
	return $str;
}


sub mold_add_data{
	my $info = shift;
	my $datafile = $info->{'LOGPATH'};
	my $rhash = $info->{'FORMDATA'};
	my $timedata = $info->{'TIME'};

	my $comment = \$rhash->{'comment'};
	
	$$comment =~ s/\n/Enc_Line_Feed/g;

	my @savedata;
	push(@savedata, $rhash->{'username'}   || "");
	push(@savedata, $rhash->{'email'}      || "");
	push(@savedata, $rhash->{'uri'}        || "");
	push(@savedata, $rhash->{'comment'}    || "");
	push(@savedata, $timedata);
	push(@savedata, $ENV{'REMOTE_ADDR'} || "");
	push(@savedata, $rhash->{'password'});	

	my $fh = *FH;
	&fileopen($fh, "+<:utf8", $datafile);
	&filelock($fh,LOCK_EX);

	my @data = <$fh>;
	if($data[$#data] =~ /^(\d*)\t(.*)$/){
		unshift(@savedata, $1 + 1);
	}else{
		unshift(@savedata, 1);
	}
	
	#二重投稿チェック
	my($oldcomment) = (split(/\t/,$data[$#data]))[4];
	if($oldcomment eq $rhash->{'comment'}){&error("二重投稿です。");}
	
	my $logmax  = $info->{'LOGMAX'};
	my $post = @data;
	my @overlog = ();
	if($logmax <= $post){
		for (my $i = 1; $i <= $post - $logmax + 1; $i++ ){
			push(@overlog, shift @data);
		}
		push(@data, join("\t", @savedata) . "\n");
		seek($fh, 0, 0);
		truncate($fh, 0);

		foreach(@data){print $fh $_};
	}else{
		seek($fh, tell $fh, 0);
		print $fh join("\t", @savedata);
		print $fh "\n";
	}
	&fileclose($fh);
	
	if(@overlog){
		fileopen($fh,">>:utf8",$info->{'OVERLOGPATH'});
		&filelock($fh,LOCK_EX);
		seek($fh,0,2);
		foreach(@overlog){print $fh $_};
		&fileclose($fh)
	}
	return;
}

sub fileopen{
	my ($fh,$mode,$filepath,$return_flag) = @_;
	
	unless(-e $filepath){
		open($fh,">",$filepath);
		close $fh;
		chmod 0600,$filepath;
		}
	if(!open($fh,$mode,$filepath)){
		if($return_flag){
			return 0;
		}else{
			&error("$filepath を開けません");
		}
	}
	return;
}

sub filelock{
	my $fh = shift;
	my $how = shift;
	eval("flock($fh,$how)");
	if($@){&error("$@ : このシステムではflockを実行できません");}
	return;
}

sub fileclose{
	my $fh = shift;
	close($fh);
	return;
}

sub get_time{
	my( $sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst ) = localtime(time);
	$year = 1900 + $year;
	$mon  = $mon + 1;
	$mon  = sprintf("%.2d",$mon);
	$mday = sprintf("%.2d",$mday);
	$wday = sprintf("%.2d",$wday);
	$hour = sprintf("%.2d",$hour);
	$min  = sprintf("%.2d",$min);
	$sec  = sprintf("%.2d",$sec);
	return "$year$mon$mday$wday$hour$min$sec";
}

__END__

